tests/testlib/merge-combination-util.sh
author Arun Kulshreshtha <akulshreshtha@janestreet.com>
Tue, 30 Aug 2022 15:29:55 -0400
changeset 49491 c6a1beba27e9
parent 46266 e8b0c519dfb3
permissions -rw-r--r--
bisect: avoid copying ancestor list for non-merge commits During a bisection, hg needs to compute a list of all ancestors for every candidate commit. This is accomplished via a bottom-up traversal of the set of candidates, during which each revision's ancestor list is populated using the ancestor list of its parent(s). Previously, this involved copying the entire list, which could be very long in if the bisection range was large. To help improve this, we can observe that each candidate commit is visited exactly once, at which point its ancestor list is copied into its children's lists and then dropped. In the case of non-merge commits, a commit's ancestor list consists exactly of its parent's list plus itself. This means that we can trivially reuse the parent's existing list for one of its non-merge children, which avoids copying entirely if that commit is the parent's only child. This makes bisections over linear ranges of commits much faster. During some informal testing in the large publicly-available `mozilla-central` repository, this noticeably sped up bisections over large ranges of history: Setup: $ cd mozilla-central $ hg bisect --reset $ hg bisect --good 0 $ hg log -r tip -T '{rev}\n' 628417 Test: $ time hg bisect --bad tip --noupdate Before: real 3m35.927s user 3m35.553s sys 0m0.319s After: real 1m41.142s user 1m40.810s sys 0m0.285s

# genmerges is the workhorse of the test-merge-combination-*.t tests.

# Given:
# - a `range` function describing the possible values for file a
# - a `isgood` function to filter out uninteresting combination
# - a `createfile` function to actually write the values for file a on the
#   filesystem
#
# it print a series of lines that look like: abcd C: output of -T {files}
# describing the file a at respectively the base, p2, p1, merge
# revision. "C" indicates that hg merge had conflicts.

genmerges () {

  (LC_ALL=C type range | grep -q 'function') || (echo >&2 "missing function: range")
  (LC_ALL=C type isgood | grep -q 'function') || (echo >&2 "missing function: isgood")
  (LC_ALL=C type createfile | grep -q 'function') || (echo >&2 "missing function: createfile")

  for base in `range` -; do
    for r1 in `range $base` -; do
      for r2 in `range $base $r1` -; do
        for m in `range $base $r1 $r2` -; do
          line="$base$r1$r2$m"
          isgood $line || continue
          hg init repo
          cd repo
          make_commit () {
            v=$1; msg=$2; file=$3;
            if [ $v != - ]; then
              createfile $v
            else
              if [ -f a ]
              then rm a
              else touch $file
              fi
            fi
            hg commit -q -Am $msg || exit 123
          }
          echo foo > foo
          make_commit $base base b
          make_commit $r1 r1 c
          hg up -r 0 -q
          make_commit $r2 r2 d
          hg merge -q -r 1 > ../output 2>&1
          if [ $? -ne 0 ]; then rm -f *.orig; hg resolve -m --all -q; fi
          if [ -s ../output ]; then conflicts=" C"; else conflicts="  "; fi
          make_commit $m m e
          if [ $m = $r1 ] && [ $m = $r2 ]
          then expected=
          elif [ $m = $r1 ]
          then if [ $base = $r2 ]
               then expected=
               else expected=a
               fi
          elif [ $m = $r2 ]
          then if [ $base = $r1 ]
               then expected=
               else expected=a
               fi
          else expected=a
          fi
          got=`hg log -r 3 --template '{files}\n' | tr -d 'e '`
          if [ "$got" = "$expected" ]
          then echo "$line$conflicts: agree on \"$got\""
          else echo "$line$conflicts: hg said \"$got\", expected \"$expected\""
          fi
          cd ../
          rm -rf repo
        done
      done
    done
  done
}